"""
Has a container for game functions.

*Classes*
---------
    Games
        Container for game functions.
"""


from .invest import Invest
from .trivia import Trivia
from .blackjack import Blackjack
from .connectFour import ConnectFour
from .hangman import Hangman
from .hex import HexGame


class Games():
    """
    Contains game classes.

    *Attributes*
    ------------
        bot: Gwendolyn
            The instance of Gwendolyn.
        invest
            Contains investment functions.
        blackjack
            Contains blackjack functions.
        connectFour
            Contains connect four functions.
        hangman
            Contains hangman functions.
        hex
            Contains hex functions
    """

    def __init__(self, bot):
        """Initialize the container."""
        self.bot = bot

        self.invest = Invest(bot)
        self.trivia = Trivia(bot)
        self.blackjack = Blackjack(bot)
        self.connectFour = ConnectFour(bot)
        self.hangman = Hangman(bot)
        self.hex = HexGame(bot)
